/*  VQF XMMS Plugin 
 *  Copyright (C) 2000  Mel Gorman (mel@skynet.ie) 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#define TABLEATTACH(widget, x, y) gtk_table_attach(GTK_TABLE(table), widget, x, x+1, y, y+1,  GTK_FILL , GTK_FILL , 0, 5)

#define INFOATTACH(name, value) { \
	sprintf(buffer, "%s %d", name, value); \
	aLabel = gtk_label_new(buffer); \
	gtk_misc_set_alignment(GTK_MISC(aLabel), 0, 0); \
	gtk_box_pack_start(GTK_BOX(vqfBox), aLabel, FALSE, FALSE, 0); \
	gtk_widget_show(aLabel); \
}
#define INFOATTACHSTRING(name, value) { \
       sprintf(buffer, "%s %s", name, value); \
       aLabel = gtk_label_new(buffer); \
       gtk_misc_set_alignment(GTK_MISC(aLabel), 0, 0); \
       gtk_box_pack_start(GTK_BOX(vqfBox), aLabel, FALSE, FALSE, 0); \
       gtk_widget_show(aLabel); \
}

#define INFOATTACHUNIT(name, value, unit) { \
	sprintf(buffer, "%s %d %s", name, value, unit); \
	aLabel = gtk_label_new(buffer); \
	gtk_misc_set_alignment(GTK_MISC(aLabel), 0, 0); \
	gtk_box_pack_start(GTK_BOX(vqfBox), aLabel, FALSE, FALSE, 0); \
	gtk_widget_show(aLabel); \
}

#include "vqf.h"
#include <string.h>
#include <pthread.h>

static GtkWidget *window=NULL, *hbox, *vbox, *id3Frame, *table, *vqfFrame, *vqfBox;

/* Widgets for ID3 */
static GtkWidget *titleLabel, 	*titleEntry;
static GtkWidget *comtLabel, 	*comtEntry;
static GtkWidget *authLabel, 	*authEntry;
static GtkWidget *cpyrLabel, 	*cpyrEntry;
static GtkWidget *extrLabel, 	*extrEntry;

static GtkWidget *buttonBox, *btnSave, *btnRemoveID3, *btnCancel;
static GtkWidget *aLabel;
static GtkWidget *vqfFileinfo;

static void idSave(GtkWidget *widget, gpointer data)
{
  static GtkWidget *messageBox = NULL;
  if (!messageBox)
  {
    messageBox = xmms_show_message("Sorry...", "Saving of ID3 Tags not yet implemented", "Ok", FALSE, NULL, NULL);
    gtk_signal_connect(GTK_OBJECT(messageBox), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroyed), &messageBox);
  }
}

static void removeID3(GtkWidget *widget, gpointer data)
{
  /* Set the text */
  gtk_entry_set_text(GTK_ENTRY(titleEntry), "");
  gtk_entry_set_text(GTK_ENTRY(comtEntry),  "");
  gtk_entry_set_text(GTK_ENTRY(authEntry),  "");
  gtk_entry_set_text(GTK_ENTRY(cpyrEntry),  "");
  gtk_entry_set_text(GTK_ENTRY(extrEntry),  "");
}
/* Function XMMS calls */
void    vqfInfoBox (char *filename)
{
  TRACE("vqfInfoBox: getting file information\n");
  char buffer[256];

  /* Get file information */
  VQFFile fileInfo;
  if (getSongInfo(filename, &fileInfo) == -1) return;
  
  /* Create window */	 
  window = gtk_window_new(GTK_WINDOW_DIALOG);
  sprintf(buffer, "File Info - %s", fileInfo.header.Name);
  gtk_window_set_title(GTK_WINDOW(window), buffer);
  gtk_window_set_policy(GTK_WINDOW(window), FALSE, FALSE, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(window), 10);
  gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroyed), &window);

  /* Create formatinng boxes and frames */ 
  hbox = gtk_hbox_new(FALSE, 10);
  vbox = gtk_vbox_new(FALSE, 10);
  vqfBox = gtk_vbox_new(FALSE, 5);
  id3Frame = gtk_frame_new("ID3 Tag:");
  vqfFrame = gtk_frame_new("VQF Info:");
  table = gtk_table_new(4, 5, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(table), 5);

  /* Attach them all to the main window */
  gtk_container_add(GTK_CONTAINER(id3Frame), table);
  gtk_container_add(GTK_CONTAINER(vqfFrame), vqfBox);
  gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), id3Frame, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(hbox), vqfFrame, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(window), hbox);

  /* Create labels */
  titleLabel 	= gtk_label_new("Title");
  comtLabel	= gtk_label_new("Comt:");
  authLabel	= gtk_label_new("Artist:");
  cpyrLabel	= gtk_label_new("Copyright:");
  extrLabel	= gtk_label_new("Extra:");
  gtk_misc_set_alignment(GTK_MISC(titleLabel), 1, 0.5);
  gtk_misc_set_alignment(GTK_MISC(comtLabel), 1, 0.5);
  gtk_misc_set_alignment(GTK_MISC(authLabel), 1, 0.5);
  gtk_misc_set_alignment(GTK_MISC(cpyrLabel), 1, 0.5);
  gtk_misc_set_alignment(GTK_MISC(extrLabel), 1, 0.5);

  /* Create entry boxes */
  titleEntry =  gtk_entry_new();
  comtEntry = gtk_entry_new();
  authEntry = gtk_entry_new();
  cpyrEntry = gtk_entry_new();
  extrEntry = gtk_entry_new();

  /* Place them */
  TABLEATTACH(titleLabel, 0, 0);
  TABLEATTACH(comtLabel,  0, 1);
  TABLEATTACH(authLabel,  0, 2);
  TABLEATTACH(cpyrLabel,  0, 3);
  TABLEATTACH(extrLabel,  0, 4);
    
  TABLEATTACH(titleEntry, 1, 0);
  TABLEATTACH(comtEntry,  1, 1);
  TABLEATTACH(authEntry,  1, 2);
  TABLEATTACH(cpyrEntry,  1, 3);
  TABLEATTACH(extrEntry,  1, 4);

  /* Set the text */
  gtk_entry_set_text(GTK_ENTRY(titleEntry), fileInfo.header.Name);
  gtk_entry_set_text(GTK_ENTRY(comtEntry),  fileInfo.header.Comt);
  gtk_entry_set_text(GTK_ENTRY(authEntry),  fileInfo.header.Auth);
  gtk_entry_set_text(GTK_ENTRY(cpyrEntry),  fileInfo.header.Cpyr);
  gtk_entry_set_text(GTK_ENTRY(extrEntry),  fileInfo.header.Extr);

  /* Create the buttons */
  buttonBox = gtk_hbutton_box_new();
  gtk_button_box_set_layout(GTK_BUTTON_BOX(buttonBox), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing(GTK_BUTTON_BOX(buttonBox), 5);
  gtk_box_pack_start(GTK_BOX(vbox), buttonBox, FALSE, FALSE, 0);

  btnSave      = gtk_button_new_with_label("Save");
  btnRemoveID3 = gtk_button_new_with_label("Remove ID3");
  btnCancel    = gtk_button_new_with_label("Cancel");
  GTK_WIDGET_SET_FLAGS(btnSave, GTK_CAN_DEFAULT);
  GTK_WIDGET_SET_FLAGS(btnCancel, GTK_CAN_DEFAULT);
  GTK_WIDGET_SET_FLAGS(btnRemoveID3, GTK_CAN_DEFAULT);
  gtk_widget_grab_default(btnSave);

  /* Connect to functions */
  gtk_signal_connect_object(GTK_OBJECT(btnSave),      "clicked", GTK_SIGNAL_FUNC(idSave), NULL);
  gtk_signal_connect_object(GTK_OBJECT(btnRemoveID3), "clicked", GTK_SIGNAL_FUNC(removeID3), NULL);
  gtk_signal_connect_object(GTK_OBJECT(btnCancel), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(window));
    
  /* Place them */
  gtk_box_pack_start(GTK_BOX(buttonBox), btnSave, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(buttonBox), btnRemoveID3, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(buttonBox), btnCancel, TRUE, TRUE, 0);

  /* Add in information for the file on the right hand side */
  INFOATTACHUNIT("Bitrate: ", 	fileInfo.header.bitRate, "b/s");
  INFOATTACHUNIT("Samplerate: ", 	fileInfo.header.samplingRate, "Hz");
  INFOATTACH    ("Channels: ", 	2);
  if (fileInfo.header.channelMode == 0) INFOATTACHSTRING("Mono", "")
  else INFOATTACHSTRING("Stereo", "")
  INFOATTACH("Filesize: ", 		fileInfo.header.Dsiz);

  /* Show them */
  gtk_widget_show(titleEntry);
  gtk_widget_show(comtEntry);
  gtk_widget_show(authEntry);
  gtk_widget_show(cpyrEntry);
  gtk_widget_show(extrEntry);
  gtk_widget_show(titleLabel);
  gtk_widget_show(comtLabel);
  gtk_widget_show(authLabel);
  gtk_widget_show(cpyrLabel);
  gtk_widget_show(extrLabel);
  gtk_widget_show(btnSave);
  gtk_widget_show(btnRemoveID3);
  gtk_widget_show(btnCancel);
  gtk_widget_show(vbox);
  gtk_widget_show(hbox);
  gtk_widget_show(buttonBox);
  gtk_widget_show(vqfBox);
  gtk_widget_show(table);
  gtk_widget_show(id3Frame);
  gtk_widget_show(vqfFrame);
  gtk_widget_show(window);

}
